#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "stack.h"

#define N 7 // broj operacija
#define MAX_LINE 80

typedef struct operatorDefs {
    char operatorType;
	int ipr;
	int spr;
	int R;
} OperatorDefs;


int IPR(OperatorDefs *opDefs, char op)
{
	int i;
	for(i = 0; i < N; ++i)
		if (op == opDefs[i].operatorType)
			return opDefs[i].ipr;
	return -1;
}

int SPR(OperatorDefs *opDefs, char op)
{
	int i;
	for(i = 0; i < N; ++i)
		if (op == opDefs[i].operatorType)
			return opDefs[i].spr;
	return NULL;
}

int Rank(OperatorDefs *opDefs, char op)
{
	int i;
	for(i = 0; i < N; ++i)
		if (op == opDefs[i].operatorType)
			return opDefs[i].R;
	return NULL;
}

int main(void) {
	
	int i, j = 0, rank = 0;
	char x, infix[MAX_LINE], *postfix;

	char operators[] = {'+', '-', '*', '/', '^', '(', ')'};
	int iPriorities[] = {2, 2, 3, 3, 5, 6, 1};
	int sPriorities[] = {2, 2, 3, 3, 4, 0, NULL};
	int R[] = {-1, -1, -1, -1, -1, NULL, NULL};

    OperatorDefs* opDefs;
	Node* node = NULL;
	
	printf("Unesite infiksni izraz (((A+(B*(C-D)))+(((E-F)*G)/H))) : ");
	fgets(infix, MAX_LINE, stdin);

	postfix = (char*)malloc(strlen(infix) * sizeof(char));

	opDefs = (OperatorDefs*)calloc(N, sizeof(OperatorDefs));

	for(i = 0; i < N; ++i) {
		opDefs[i].operatorType = operators[i];
		opDefs[i].ipr = iPriorities[i];
		opDefs[i].spr = sPriorities[i];
		opDefs[i].R = R[i];
	}

	for (i = 0; i < strlen(infix); ++i)
	{
		if (isalpha(infix[i]))
		{
			// proveri da li je operand
			postfix[j++] = infix[i];
			++rank;
		}
		else
		{
			while(!isEmptyStack(node) && IPR(opDefs, infix[i]) <= SPR(opDefs, node->x))
			{
				x = pop(&node);
				postfix[j++] = x;
				rank += Rank(opDefs, x);

				if (rank < 1) {
					printf("Nepravilan izraz!\n");
					exit(EXIT_FAILURE);
				}
			}

			if (infix[i] != ')')
			    push(&node, infix[i]);
			else
				x = pop(&node);
		}
	}

	while(!isEmptyStack(node))
	{
		x = pop(&node);
		postfix[j++] = x;
		rank += Rank(opDefs, x);

		if (rank < 1) {
			printf("Nepravilan izraz!\n");
			exit(EXIT_FAILURE);
		}
	}

	printf("Postfiksni izraz je: ");
	postfix[j] = '\0';
	puts(postfix);

	return EXIT_SUCCESS;
}